/* $Id: box.c,v 1.1 2001/10/13 11:01:44 thayne Exp $
******************************************************************************

   Graphics library for GGI. Boxes.

   Copyright (C) 1999 Marcus Sundberg	[marcus@ggi-project.org]

   Permission is hereby granted, free of charge, to any person obtaining a
   copy of this software and associated documentation files (the "Software"),
   to deal in the Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish, distribute, sublicense,
   and/or sell copies of the Software, and to permit persons to whom the
   Software is furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included in
   all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
   THE AUTHOR(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
   IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

******************************************************************************
*/

#include <string.h>

#include "linear-16-a8-z8-lib.h"


int
GGI_linear_16_a8_z8_drawbox(ggi_visual *vis,
                            int x, int y,
                            int w, int h)
{
	uint16 *dest;
	uint16 color;
	int pixperline, xcount, xend, yend;

	LIBGGICLIP_XYWH(vis, x, y, w, h);
	PREPARE_FB(vis);

	color = LIBGGI_GC_FGCOLOR(vis);
	
	pixperline = LIBGGI_FB_W_STRIDE(vis) / 2;

#warning dont use calc_pixel - faster to use offsets to access alpha buf
	for (dest = (uint16*)LIBGGI_CURWRITE(vis) + y * pixperline, yend = y + h;
			 y != yend;
			 dest += pixperline, y++) {
		for (xcount = x, xend = x + w; xcount != xend; xcount++) {
			dest[xcount] = calc_pixel(vis, xcount, y, color, dest[xcount]);
		}
	}

	return 0;
}


#warning I doubt this is correct because it doesnt work with alpha from the buffer
int
GGI_linear_16_a8_z8_putbox(ggi_visual *vis,
                           int x, int y,
                           int w, int h,
                           void *buffer)
{
	uint16 *src = buffer;
	int srcwidth = w;
	uint16 *dest;
	int pixperline, xcount, xend, yend;

	LIBGGICLIP_PUTBOX(vis,x,y,w,h,src,srcwidth, );
	PREPARE_FB(vis);

	pixperline = LIBGGI_FB_W_STRIDE(vis) / 2;

#warning dont use calc_pixel - faster to use offsets to access alpha buf
	for (dest = (uint16*)LIBGGI_CURWRITE(vis) + y * pixperline, yend = y + h;
			 y != yend;
			 dest += pixperline, src += srcwidth, y++) {
		for (xcount = x, xend = x + w; xcount != xend; xcount++) {
			dest[xcount] = calc_pixel(vis, xcount, y, src[xcount], dest[xcount]);
		}
	}

	return 0;
}
